%define oname DirectFB
%define api 1.6
%define major 0
%define libdirect %mklibname direct %{api} %{major}
%define libdirectfb %mklibname directfb %{api} %{major}
%define libfusion %mklibname fusion %{api} %{major}
%define devname %mklibname %{name} -d

# Multiple applications support
# Requires fusion kernel module
%bcond_with multi

Summary:	Hardware graphics acceleration library
Name:		directfb
Version:	1.6.3
Release:	1
License:	LGPLv2+
Group:		System/Libraries
Url:		http://www.directfb.org/
Source0:	http://directfb.org/downloads/Core/%{oname}-1.6/%{oname}-%{version}.tar.gz
# from Debian
Patch0:		03_link_static_sysfs.patch
Patch1:		DirectFB-1.6.1-link-static-ar.patch
# Explicitly link with -lm. Was failing only on x86_64, but not on i586,
# apparently because -O3 was generating code to bypass libm on i586.
Patch3:		DirectFB-1.2.7-sincos-x86_64.patch
# remove common linkage of x11 system and x11 input driver
# it makes directfb segfault
# (this is a workaround, not a proper upstreamable fix)
Patch4:		DirectFB-1.4.2-x11-linkage.patch
# from Debian #401296, 93_fix_unicode_key_handling.patch
Patch6:		DirectFB-1.4.2-unicode.patch
Patch7:		DirectFB-1.6.1-svg-includedir.patch
Patch8:		DirectFB-1.6.1-zlib.patch
Patch9:		DirectFB-1.5.3-add-missing-davinci-files.patch

BuildRequires:	bzip2-devel
BuildRequires:	jpeg-devel
BuildRequires:	sysfsutils-devel
BuildRequires:	pkgconfig(egl)
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(gbm)
BuildRequires:	pkgconfig(glesv2)
BuildRequires:	pkgconfig(jasper)
BuildRequires:	pkgconfig(libdrm)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libsvg-cairo)
BuildRequires:	pkgconfig(libvncserver)
BuildRequires:	pkgconfig(vdpau)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xproto)
BuildRequires:	pkgconfig(zlib)
%if %{with multi}
BuildRequires:	fusion-devel >= 3.0
%endif
Conflicts:	%{_lib}directfb1.6_0 < 1.6.3
Conflicts:	%{_lib}directfb-devel < 1.6.3

%description
DirectFB hardware graphics acceleration utilities and interfaces.

%files
%{_bindir}/dfbdump
%{_bindir}/dfbdumpinput
%{_bindir}/dfbfx
%{_bindir}/dfbg
%{_bindir}/dfbinfo
%{_bindir}/dfbinput
%{_bindir}/dfbinspector
%{_bindir}/dfblayer
%{_bindir}/dfbmaster
%{_bindir}/dfbpenmount
%{_bindir}/dfbscreen
%{_bindir}/directfb-config
%{_bindir}/directfb-csource
%{_bindir}/mkdfiff
%{_bindir}/mkdgiff
%{_bindir}/mkdgifft
%{_bindir}/pxa3xx_dump
%{_datadir}/directfb-%{version}/
%{_libdir}/directfb-%{api}-%{major}/
%{_mandir}/man1/directfb-csource.1*
%{_mandir}/man1/dfbg.1*
%{_mandir}/man5/directfbrc.5*

#----------------------------------------------------------------------------

%package -n %{libdirect}
Summary:	The direct library, a part of DirectFB
Group:		System/Libraries
Conflicts:	%{_lib}directfb1.6_0 < 1.6.3

%description -n %{libdirect}
The direct library, a part of DirectFB.

%files -n %{libdirect}
%{_libdir}/libdirect-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libdirectfb}
Summary:	Shared library part of %{oname}
Group:		System/Libraries
# We use >= instead of = to avoid build issues when library major changes
Requires:	%{name} >= %{EVRD}

%description -n %{libdirectfb}
DirectFB hardware graphics acceleration main library.

%files -n %{libdirectfb}
%{_libdir}/libdirectfb-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libfusion}
Summary:	The fusion library, a part of DirectFB
Group:		System/Libraries
Conflicts:	%{_lib}directfb1.6_0 < 1.6.3

%description -n %{libfusion}
The fusion library, a part of DirectFB.

%files -n %{libfusion}
%{_libdir}/libfusion-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Header files for compiling DirectFB applications
Group:		Development/C
Requires:	%{libdirect} = %{EVRD}
Requires:	%{libdirectfb} = %{EVRD}
Requires:	%{libfusion} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}

%description -n %{devname}
DirectFB header files for building applications based on %{oname}.

%files -n %{devname}
%{multiarch_bindir}/directfb-config
%{_includedir}/directfb
%{_includedir}/directfb-internal
%{_libdir}/pkgconfig/*
%{_libdir}/*.so

#----------------------------------------------------------------------------

%package doc
Summary:	DirectFB - documentation
Group:		Documentation

%description doc
DirectFB documentation and examples.

%files doc
%doc docs/html/*
%doc README* AUTHORS NEWS TODO

#----------------------------------------------------------------------------

%prep
%setup  -q -n %{oname}-%{version}
%patch0 -p1 -b .sysfs
%patch1 -p1 -b .link-static-ar
%patch3 -p1
%patch4 -p1 -b .x11-linkage
%patch6 -p1 -b .unicode
%patch7 -p0 -b .svgdir
%patch8 -p1 -b .zlib
%patch9 -p1 -b .davinci

# Needed for Qt 5 as of Qt 5.0.1:
sed -i -e '/define __typeof/d' lib/direct/os/linux/glibc/types.h
find . -name "*.h" |xargs sed -i -e 's,__typeof__,typeof,g'

autoreconf -if

%build
%configure2_5x \
	--disable-maintainer-mode \
	--enable-shared \
	--disable-static \
	--disable-fast-install \
	--disable-debug \
	--enable-zlib \
%ifarch %{ix86}
	--disable-mmx \
	--disable-sse \
%endif
%if %{with multi}
	--enable-multi
%else
	--disable-multi
%endif

%make LIBS="-lbz2 -ldl -pthread -lpthread -lrt"

%install
%makeinstall_std

# multiarch policy
%multiarch_binaries %{buildroot}%{_bindir}/directfb-config


%changelog
* Thu Jul 03 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.6.3-1
+ Revision: cc550d7
- New version 1.6.3, split library package, package utilities and interfaces into directfb package


